/*
 * vim:nomodifiable
 *
 * ************* DO NOT EDIT **************
 * This file is autogenerated from all.h.m4
 * ****************************************
 */
/** @file
 * @brief HID report descriptor - all usages
 *
 * Copyright (C) 2010 Nikolai Kondrashov
 *
 * This file is part of hidrd.
 *
 * Hidrd is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Hidrd is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with hidrd; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * @author Nikolai Kondrashov <spbnick@gmail.com>
 */

#ifndef __HIDRD_USAGE_ALL_H__
#define __HIDRD_USAGE_ALL_H__

#include "hidrd/cfg.h"
#include "hidrd/util/num.h"
#include "hidrd/usage/page.h"
#include "hidrd/usage/id.h"
#include "hidrd/usage/type.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef enum hidrd_usage {
#define _U(_page, _id) (((HIDRD_USAGE_PAGE_##_page) << 16) | (_id))

    HIDRD_USAGE_UNDEFINED = _U(UNDEFINED, 0x0000),

    /*
     * Generic desktop controls page
     */
#define _PU(_id) _U(DESKTOP, _id)

    /** Pointer (CP) */
    HIDRD_USAGE_DESKTOP_POINTER = _PU(0x0001),
    /** Mouse (CA) */
    HIDRD_USAGE_DESKTOP_MOUSE = _PU(0x0002),
    /** Joystik (CA) */
    HIDRD_USAGE_DESKTOP_JOYSTIK = _PU(0x0004),
    /** Gamepad (CA) */
    HIDRD_USAGE_DESKTOP_GAMEPAD = _PU(0x0005),
    /** Keyboard (CA) */
    HIDRD_USAGE_DESKTOP_KEYBOARD = _PU(0x0006),
    /** Keypad (CA) */
    HIDRD_USAGE_DESKTOP_KEYPAD = _PU(0x0007),
    /** Multi-axis controller (CA) */
    HIDRD_USAGE_DESKTOP_MULTI_AXIS_CTRL = _PU(0x0008),
    /** Tablet PC system controls (CA) */
    HIDRD_USAGE_DESKTOP_TABLET_PC_SYSTEM = _PU(0x0009),
    /** X (DV) */
    HIDRD_USAGE_DESKTOP_X = _PU(0x0030),
    /** Y (DV) */
    HIDRD_USAGE_DESKTOP_Y = _PU(0x0031),
    /** Z (DV) */
    HIDRD_USAGE_DESKTOP_Z = _PU(0x0032),
    /** Rx (DV) */
    HIDRD_USAGE_DESKTOP_RX = _PU(0x0033),
    /** Ry (DV) */
    HIDRD_USAGE_DESKTOP_RY = _PU(0x0034),
    /** Rz (DV) */
    HIDRD_USAGE_DESKTOP_RZ = _PU(0x0035),
    /** Slider (DV) */
    HIDRD_USAGE_DESKTOP_SLIDER = _PU(0x0036),
    /** Dial (DV) */
    HIDRD_USAGE_DESKTOP_DIAL = _PU(0x0037),
    /** Wheel (DV) */
    HIDRD_USAGE_DESKTOP_WHEEL = _PU(0x0038),
    /** Hat switch (DV) */
    HIDRD_USAGE_DESKTOP_HAT_SWITCH = _PU(0x0039),
    /** Counted buffer (CL) */
    HIDRD_USAGE_DESKTOP_COUNTED_BUFFER = _PU(0x003A),
    /** Byte count (DV) */
    HIDRD_USAGE_DESKTOP_BYTE_COUNT = _PU(0x003B),
    /** Motion wakeup (OSC) */
    HIDRD_USAGE_DESKTOP_MOTION_WAKEUP = _PU(0x003C),
    /** Start (OOC) */
    HIDRD_USAGE_DESKTOP_START = _PU(0x003D),
    /** Select (OOC) */
    HIDRD_USAGE_DESKTOP_SELECT = _PU(0x003E),
    /** Vx (DV) */
    HIDRD_USAGE_DESKTOP_VX = _PU(0x0040),
    /** Vy (DV) */
    HIDRD_USAGE_DESKTOP_VY = _PU(0x0041),
    /** Vz (DV) */
    HIDRD_USAGE_DESKTOP_VZ = _PU(0x0042),
    /** Vbrx (DV) */
    HIDRD_USAGE_DESKTOP_VBRX = _PU(0x0043),
    /** Vbry (DV) */
    HIDRD_USAGE_DESKTOP_VBRY = _PU(0x0044),
    /** Vbrz (DV) */
    HIDRD_USAGE_DESKTOP_VBRZ = _PU(0x0045),
    /** Vno (DV) */
    HIDRD_USAGE_DESKTOP_VNO = _PU(0x0046),
    /** Feature notification (DV,DF) */
    HIDRD_USAGE_DESKTOP_FEATURE_NOTIFICATION = _PU(0x0047),
    /** Resolution multiplier (DV) */
    HIDRD_USAGE_DESKTOP_RESOLUTION_MULTIPLIER = _PU(0x0048),
    /** System control (CA) */
    HIDRD_USAGE_DESKTOP_SYS_CONTROL = _PU(0x0080),
    /** System power down (OSC) */
    HIDRD_USAGE_DESKTOP_SYS_POWER_DOWN = _PU(0x0081),
    /** System sleep (OSC) */
    HIDRD_USAGE_DESKTOP_SYS_SLEEP = _PU(0x0082),
    /** System wake up (OSC) */
    HIDRD_USAGE_DESKTOP_SYS_WAKE_UP = _PU(0x0083),
    /** System context menu (OSC) */
    HIDRD_USAGE_DESKTOP_SYS_CONTEXT_MENU = _PU(0x0084),
    /** System main menu (OSC) */
    HIDRD_USAGE_DESKTOP_SYS_MAIN_MENU = _PU(0x0085),
    /** System app menu (OSC) */
    HIDRD_USAGE_DESKTOP_SYS_APP_MENU = _PU(0x0086),
    /** System menu help (OSC) */
    HIDRD_USAGE_DESKTOP_SYS_MENU_HELP = _PU(0x0087),
    /** System menu exit (OSC) */
    HIDRD_USAGE_DESKTOP_SYS_MENU_EXIT = _PU(0x0088),
    /** System menu select (OSC) */
    HIDRD_USAGE_DESKTOP_SYS_MENU_SELECT = _PU(0x0089),
    /** System menu right (RTC) */
    HIDRD_USAGE_DESKTOP_SYS_MENU_RIGHT = _PU(0x008A),
    /** System menu left (RTC) */
    HIDRD_USAGE_DESKTOP_SYS_MENU_LEFT = _PU(0x008B),
    /** System menu up (RTC) */
    HIDRD_USAGE_DESKTOP_SYS_MENU_UP = _PU(0x008C),
    /** System menu down (RTC) */
    HIDRD_USAGE_DESKTOP_SYS_MENU_DOWN = _PU(0x008D),
    /** System cold restart (OSC) */
    HIDRD_USAGE_DESKTOP_SYS_COLD_RESTART = _PU(0x008E),
    /** System warm restart (OSC) */
    HIDRD_USAGE_DESKTOP_SYS_WARM_RESTART = _PU(0x008F),
    /** D-pad up (OOC) */
    HIDRD_USAGE_DESKTOP_D_PAD_UP = _PU(0x0090),
    /** D-pad down (OOC) */
    HIDRD_USAGE_DESKTOP_D_PAD_DOWN = _PU(0x0091),
    /** D-pad right (OOC) */
    HIDRD_USAGE_DESKTOP_D_PAD_RIGHT = _PU(0x0092),
    /** D-pad left (OOC) */
    HIDRD_USAGE_DESKTOP_D_PAD_LEFT = _PU(0x0093),
    /** System dock (OSC) */
    HIDRD_USAGE_DESKTOP_SYS_DOCK = _PU(0x00A0),
    /** System undock (OSC) */
    HIDRD_USAGE_DESKTOP_SYS_UNDOCK = _PU(0x00A1),
    /** System setup (OSC) */
    HIDRD_USAGE_DESKTOP_SYS_SETUP = _PU(0x00A2),
    /** System break (OSC) */
    HIDRD_USAGE_DESKTOP_SYS_BREAK = _PU(0x00A3),
    /** System debugger break (OSC) */
    HIDRD_USAGE_DESKTOP_SYS_DBGR_BREAK = _PU(0x00A4),
    /** Application break (OSC) */
    HIDRD_USAGE_DESKTOP_APP_BREAK = _PU(0x00A5),
    /** Application debugger break (OSC) */
    HIDRD_USAGE_DESKTOP_APP_DBGR_BREAK = _PU(0x00A6),
    /** System speaker mute (OSC) */
    HIDRD_USAGE_DESKTOP_SYS_SPEAKER_MUTE = _PU(0x00A7),
    /** System hibernate (OSC) */
    HIDRD_USAGE_DESKTOP_SYS_HIBERNATE = _PU(0x00A8),
    /** System display invert (OSC) */
    HIDRD_USAGE_DESKTOP_SYS_DSPL_INVERT = _PU(0x00B0),
    /** System display internal (OSC) */
    HIDRD_USAGE_DESKTOP_SYS_DSPL_INTERNAL = _PU(0x00B1),
    /** System display external (OSC) */
    HIDRD_USAGE_DESKTOP_SYS_DSPL_EXTERNAL = _PU(0x00B2),
    /** System display both (OSC) */
    HIDRD_USAGE_DESKTOP_SYS_DSPL_BOTH = _PU(0x00B3),
    /** System display dual (OSC) */
    HIDRD_USAGE_DESKTOP_SYS_DSPL_DUAL = _PU(0x00B4),
    /** System display toggle int/ext (OSC) */
    HIDRD_USAGE_DESKTOP_SYS_DSPL_TOGGLE_INT_EXT = _PU(0x00B5),
    /** System display swap primary/secondary (OSC) */
    HIDRD_USAGE_DESKTOP_SYS_DSPL_SWAP_1_2 = _PU(0x00B6),
    /** System display LCD autoscale (OSC) */
    HIDRD_USAGE_DESKTOP_SYS_DSPL_LCD_AUTOSCALE = _PU(0x00B7),

#undef _PU

    /*
     * Keyboard/keypad page
     */
#define _PU(_id) _U(KEYBOARD, _id)

    /** No event (Sel) */
    HIDRD_USAGE_KEYBOARD_NONE = _PU(0x0000),
    /** Keyboard ErrorRollOver (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_ERRORROLLOVER = _PU(0x0001),
    /** Keyboard POSTFail (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_POSTFAIL = _PU(0x0002),
    /** Keyboard ErrorUndefined (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_ERRORUNDEFINED = _PU(0x0003),
    /** Keyboard a and A (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_A = _PU(0x0004),
    /** Keyboard b and B (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_B = _PU(0x0005),
    /** Keyboard c and C (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_C = _PU(0x0006),
    /** Keyboard d and D (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_D = _PU(0x0007),
    /** Keyboard e and E (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_E = _PU(0x0008),
    /** Keyboard f and F (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_F = _PU(0x0009),
    /** Keyboard g and G (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_G = _PU(0x000A),
    /** Keyboard h and H (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_H = _PU(0x000B),
    /** Keyboard i and I (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_I = _PU(0x000C),
    /** Keyboard j and J (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_J = _PU(0x000D),
    /** Keyboard k and K (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_K = _PU(0x000E),
    /** Keyboard l and L (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_L = _PU(0x000F),
    /** Keyboard m and M (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_M = _PU(0x0010),
    /** Keyboard n and N (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_N = _PU(0x0011),
    /** Keyboard o and O (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_O = _PU(0x0012),
    /** Keyboard p and P (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_P = _PU(0x0013),
    /** Keyboard q and Q (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_Q = _PU(0x0014),
    /** Keyboard r and R (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_R = _PU(0x0015),
    /** Keyboard s and S (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_S = _PU(0x0016),
    /** Keyboard t and T (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_T = _PU(0x0017),
    /** Keyboard u and U (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_U = _PU(0x0018),
    /** Keyboard v and V (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_V = _PU(0x0019),
    /** Keyboard w and W (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_W = _PU(0x001A),
    /** Keyboard x and X (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_X = _PU(0x001B),
    /** Keyboard y and Y (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_Y = _PU(0x001C),
    /** Keyboard z and Z (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_Z = _PU(0x001D),
    /** Keyboard 1 and ! (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_1_AND_EXCLAM = _PU(0x001E),
    /** Keyboard 2 and @ (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_2_AND_AT = _PU(0x001F),
    /** Keyboard 3 and number (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_3_AND_NUMBER = _PU(0x0020),
    /** Keyboard 4 and $ (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_4_AND_DOLLAR = _PU(0x0021),
    /** Keyboard 5 and % (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_5_AND_PERCENT = _PU(0x0022),
    /** Keyboard 6 and ^ (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_6_AND_CARET = _PU(0x0023),
    /** Keyboard 7 and & (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_7_AND_AMP = _PU(0x0024),
    /** Keyboard 8 and * (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_8_AND_STAR = _PU(0x0025),
    /** Keyboard 9 and left parenthesis (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_9_AND_LEFT_PAREN = _PU(0x0026),
    /** Keyboard 0 and right parenthesis (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_0_AND_RIGHT_PAREN = _PU(0x0027),
    /** Keyboard Return (ENTER) (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_ENTER = _PU(0x0028),
    /** Keyboard Escape (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_ESCAPE = _PU(0x0029),
    /** Keyboard Delete (Backspace) (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_DELETE = _PU(0x002A),
    /** Keyboard Tab (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_TAB = _PU(0x002B),
    /** Keyboard spacebar (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_SPACEBAR = _PU(0x002C),
    /** Keyboard - and _ (underscore) (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_MINUS_AND_UNDERSCORE = _PU(0x002D),
    /** Keyboard = and + (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_EQUALS_AND_PLUS = _PU(0x002E),
    /** Keyboard [ and { (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_LBOXBRACKET_AND_LBRACE = _PU(0x002F),
    /** Keyboard ] and } (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_RBOXBRACKET_AND_RBRACE = _PU(0x0030),
    /** Keyboard backslash and | (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_BACKSLASH_AND_PIPE = _PU(0x0031),
    /** Keyboard non-US number and ~ (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_NON_US_NUMBER_AND_TILDE = _PU(0x0032),
    /** Keyboard ; and : (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_SEMICOLON_AND_COLON = _PU(0x0033),
    /** Keyboard ‘ and “ (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_QUOT_AND_DBLQUOT = _PU(0x0034),
    /** Keyboard grave accent and tilde (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_GRAVE_ACCENT_AND_TILDE = _PU(0x0035),
    /** Keyboard  (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_COMMA_AND_LT = _PU(0x0036),
    /** Keyboard . and > (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_PERIOD_AND_GT = _PU(0x0037),
    /** Keyboard / and ? (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_SLASH_AND_QUESTION = _PU(0x0038),
    /** Keyboard Caps Lock (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_CAPS_LOCK = _PU(0x0039),
    /** Keyboard F1 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_F1 = _PU(0x003A),
    /** Keyboard F2 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_F2 = _PU(0x003B),
    /** Keyboard F3 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_F3 = _PU(0x003C),
    /** Keyboard F4 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_F4 = _PU(0x003D),
    /** Keyboard F5 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_F5 = _PU(0x003E),
    /** Keyboard F6 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_F6 = _PU(0x003F),
    /** Keyboard F7 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_F7 = _PU(0x0040),
    /** Keyboard F8 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_F8 = _PU(0x0041),
    /** Keyboard F9 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_F9 = _PU(0x0042),
    /** Keyboard F10 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_F10 = _PU(0x0043),
    /** Keyboard F11 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_F11 = _PU(0x0044),
    /** Keyboard F12 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_F12 = _PU(0x0045),
    /** Keyboard Print Screen (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_PRINT_SCREEN = _PU(0x0046),
    /** Keyboard Scroll Lock (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_SCROLL_LOCK = _PU(0x0047),
    /** Keyboard Pause (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_PAUSE = _PU(0x0048),
    /** Keyboard Insert (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_INSERT = _PU(0x0049),
    /** Keyboard Home (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_HOME = _PU(0x004A),
    /** Keyboard PageUp (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_PAGEUP = _PU(0x004B),
    /** Keyboard Delete Forward (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_DELETE_FORWARD = _PU(0x004C),
    /** Keyboard End (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_END = _PU(0x004D),
    /** Keyboard PageDown (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_PAGEDOWN = _PU(0x004E),
    /** Keyboard RightArrow (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_RIGHTARROW = _PU(0x004F),
    /** Keyboard LeftArrow (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_LEFTARROW = _PU(0x0050),
    /** Keyboard DownArrow (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_DOWNARROW = _PU(0x0051),
    /** Keyboard UpArrow (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_UPARROW = _PU(0x0052),
    /** Keypad Num Lock and Clear (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_NUM_LOCK_AND_CLEAR = _PU(0x0053),
    /** Keypad / (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_SLASH = _PU(0x0054),
    /** Keypad * (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_STAR = _PU(0x0055),
    /** Keypad - (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_MINUS = _PU(0x0056),
    /** Keypad + (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_PLUS = _PU(0x0057),
    /** Keypad Enter (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_ENTER = _PU(0x0058),
    /** Keypad 1 and End (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_1_AND_END = _PU(0x0059),
    /** Keypad 2 and Down Arrow (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_2_AND_DOWNARROW = _PU(0x005A),
    /** Keypad 3 and PageDn (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_3_AND_PAGEDN = _PU(0x005B),
    /** Keypad 4 and Left Arrow (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_4_AND_LEFTARROW = _PU(0x005C),
    /** Keypad 5 (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_5 = _PU(0x005D),
    /** Keypad 6 and Right Arrow (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_6_AND_RIGHTARROW = _PU(0x005E),
    /** Keypad 7 and Home (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_7_AND_HOME = _PU(0x005F),
    /** Keypad 8 and Up Arrow (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_8_AND_UPARROW = _PU(0x0060),
    /** Keypad 9 and PageUp (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_9_AND_PAGEUP = _PU(0x0061),
    /** Keypad 0 and Insert (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_0_AND_INSERT = _PU(0x0062),
    /** Keypad . and Delete (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_PERIOD_AND_DELETE = _PU(0x0063),
    /** Keyboard non-US backslash and | (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_NON_US_BACKSLASH_AND_PIPE = _PU(0x0064),
    /** Keyboard Application (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_APPLICATION = _PU(0x0065),
    /** Keyboard Power (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_POWER = _PU(0x0066),
    /** Keypad = (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_EQUALS = _PU(0x0067),
    /** Keyboard F13 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_F13 = _PU(0x0068),
    /** Keyboard F14 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_F14 = _PU(0x0069),
    /** Keyboard F15 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_F15 = _PU(0x006A),
    /** Keyboard F16 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_F16 = _PU(0x006B),
    /** Keyboard F17 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_F17 = _PU(0x006C),
    /** Keyboard F18 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_F18 = _PU(0x006D),
    /** Keyboard F19 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_F19 = _PU(0x006E),
    /** Keyboard F20 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_F20 = _PU(0x006F),
    /** Keyboard F21 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_F21 = _PU(0x0070),
    /** Keyboard F22 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_F22 = _PU(0x0071),
    /** Keyboard F23 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_F23 = _PU(0x0072),
    /** Keyboard F24 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_F24 = _PU(0x0073),
    /** Keyboard Execute (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_EXECUTE = _PU(0x0074),
    /** Keyboard Help (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_HELP = _PU(0x0075),
    /** Keyboard Menu (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_MENU = _PU(0x0076),
    /** Keyboard Select (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_SELECT = _PU(0x0077),
    /** Keyboard Stop (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_STOP = _PU(0x0078),
    /** Keyboard Again (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_AGAIN = _PU(0x0079),
    /** Keyboard Undo (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_UNDO = _PU(0x007A),
    /** Keyboard Cut (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_CUT = _PU(0x007B),
    /** Keyboard Copy (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_COPY = _PU(0x007C),
    /** Keyboard Paste (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_PASTE = _PU(0x007D),
    /** Keyboard Find (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_FIND = _PU(0x007E),
    /** Keyboard Mute (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_MUTE = _PU(0x007F),
    /** Keyboard Volume Up (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_VOLUME_UP = _PU(0x0080),
    /** Keyboard Volume Down (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_VOLUME_DOWN = _PU(0x0081),
    /** Keyboard locking Caps Lock (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_LOCKING_CAPS_LOCK = _PU(0x0082),
    /** Keyboard locking Num Lock (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_LOCKING_NUM_LOCK = _PU(0x0083),
    /** Keyboard locking Scroll Lock (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_LOCKING_SCROLL_LOCK = _PU(0x0084),
    /** Keypad comma (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_COMMA = _PU(0x0085),
    /** Keypad = (AS/400) (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_EQUALS_AS_400 = _PU(0x0086),
    /** Keyboard International1 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_INTL1 = _PU(0x0087),
    /** Keyboard International2 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_INTL2 = _PU(0x0088),
    /** Keyboard International3 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_INTL3 = _PU(0x0089),
    /** Keyboard International4 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_INTL4 = _PU(0x008A),
    /** Keyboard International5 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_INTL5 = _PU(0x008B),
    /** Keyboard International6 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_INTL6 = _PU(0x008C),
    /** Keyboard International7 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_INTL7 = _PU(0x008D),
    /** Keyboard International8 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_INTL8 = _PU(0x008E),
    /** Keyboard International9 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_INTL9 = _PU(0x008F),
    /** Keyboard LANG1 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_LANG1 = _PU(0x0090),
    /** Keyboard LANG2 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_LANG2 = _PU(0x0091),
    /** Keyboard LANG3 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_LANG3 = _PU(0x0092),
    /** Keyboard LANG4 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_LANG4 = _PU(0x0093),
    /** Keyboard LANG5 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_LANG5 = _PU(0x0094),
    /** Keyboard LANG6 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_LANG6 = _PU(0x0095),
    /** Keyboard LANG7 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_LANG7 = _PU(0x0096),
    /** Keyboard LANG8 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_LANG8 = _PU(0x0097),
    /** Keyboard LANG9 (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_LANG9 = _PU(0x0098),
    /** Keyboard Alternate Erase (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_ALTERNATE_ERASE = _PU(0x0099),
    /** Keyboard SysReq/Attention (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_SYSREQ_OR_ATTENTION = _PU(0x009A),
    /** Keyboard Cancel (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_CANCEL = _PU(0x009B),
    /** Keyboard Clear (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_CLEAR = _PU(0x009C),
    /** Keyboard Prior (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_PRIOR = _PU(0x009D),
    /** Keyboard Return (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_RETURN = _PU(0x009E),
    /** Keyboard Separator (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_SEPARATOR = _PU(0x009F),
    /** Keyboard Out (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_OUT = _PU(0x00A0),
    /** Keyboard Oper (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_OPER = _PU(0x00A1),
    /** Keyboard Clear/Again (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_CLEAR_OR_AGAIN = _PU(0x00A2),
    /** Keyboard CrSel/Props (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_CRSEL_OR_PROPS = _PU(0x00A3),
    /** Keyboard ExSel (Sel) */
    HIDRD_USAGE_KEYBOARD_KB_EXSEL = _PU(0x00A4),
    /** Keypad 00 (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_00 = _PU(0x00B0),
    /** Keypad 000 (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_000 = _PU(0x00B1),
    /** Thousands separator (Sel) */
    HIDRD_USAGE_KEYBOARD_THOUSANDS_SEPARATOR = _PU(0x00B2),
    /** Decimal separator (Sel) */
    HIDRD_USAGE_KEYBOARD_DECIMAL_SEPARATOR = _PU(0x00B3),
    /** Currency unit (Sel) */
    HIDRD_USAGE_KEYBOARD_CURRENCY_UNIT = _PU(0x00B4),
    /** Currency sub-unit (Sel) */
    HIDRD_USAGE_KEYBOARD_CURRENCY_SUBUNIT = _PU(0x00B5),
    /** Keypad left parenthesis (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_LEFT_PAREN = _PU(0x00B6),
    /** Keypad right parenthesis (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_RIGHT_PAREN = _PU(0x00B7),
    /** Keypad { (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_LEFT_BRACE = _PU(0x00B8),
    /** Keypad } (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_RIGHT_BRACE = _PU(0x00B9),
    /** Keypad Tab (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_TAB = _PU(0x00BA),
    /** Keypad Backspace (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_BACKSPACE = _PU(0x00BB),
    /** Keypad A (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_A = _PU(0x00BC),
    /** Keypad B (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_B = _PU(0x00BD),
    /** Keypad C (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_C = _PU(0x00BE),
    /** Keypad D (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_D = _PU(0x00BF),
    /** Keypad E (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_E = _PU(0x00C0),
    /** Keypad F (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_F = _PU(0x00C1),
    /** Keypad XOR (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_XOR = _PU(0x00C2),
    /** Keypad ^ (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_CARET = _PU(0x00C3),
    /** Keypad % (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_PERCENT = _PU(0x00C4),
    /** Keypad < (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_LT = _PU(0x00C5),
    /** Keypad > (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_GT = _PU(0x00C6),
    /** Keypad & (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_AMP = _PU(0x00C7),
    /** Keypad && (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_DBLAMP = _PU(0x00C8),
    /** Keypad | (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_PIPE = _PU(0x00C9),
    /** Keypad || (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_DBLPIPE = _PU(0x00CA),
    /** Keypad : (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_COLON = _PU(0x00CB),
    /** Keypad number (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_NUMBER = _PU(0x00CC),
    /** Keypad Space (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_SPACE = _PU(0x00CD),
    /** Keypad @ (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_AT = _PU(0x00CE),
    /** Keypad ! (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_EXCLAMATION = _PU(0x00CF),
    /** Keypad Memory Store (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_MEM_STORE = _PU(0x00D0),
    /** Keypad Memory Recall (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_MEM_RECALL = _PU(0x00D1),
    /** Keypad Memory Clear (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_MEM_CLEAR = _PU(0x00D2),
    /** Keypad Memory Add (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_MEM_ADD = _PU(0x00D3),
    /** Keypad Memory Subtract (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_MEM_SUBTRACT = _PU(0x00D4),
    /** Keypad Memory Multiply (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_MEM_MULTIPLY = _PU(0x00D5),
    /** Keypad Memory Divide (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_MEM_DIVIDE = _PU(0x00D6),
    /** Keypad +/- (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_PLUS_MINUS = _PU(0x00D7),
    /** Keypad Clear (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_CLEAR = _PU(0x00D8),
    /** Keypad Clear Entry (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_CLEAR_ENTRY = _PU(0x00D9),
    /** Keypad Binary (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_BINARY = _PU(0x00DA),
    /** Keypad Octal (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_OCTAL = _PU(0x00DB),
    /** Keypad Decimal (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_DECIMAL = _PU(0x00DC),
    /** Keypad Hexadecimal (Sel) */
    HIDRD_USAGE_KEYBOARD_KP_HEXADECIMAL = _PU(0x00DD),
    /** Keyboard left control (DV) */
    HIDRD_USAGE_KEYBOARD_KB_LEFTCONTROL = _PU(0x00E0),
    /** Keyboard left shift (DV) */
    HIDRD_USAGE_KEYBOARD_KB_LEFTSHIFT = _PU(0x00E1),
    /** Keyboard left alt (DV) */
    HIDRD_USAGE_KEYBOARD_KB_LEFTALT = _PU(0x00E2),
    /** Keyboard left GUI (DV) */
    HIDRD_USAGE_KEYBOARD_KB_LEFT_GUI = _PU(0x00E3),
    /** Keyboard right control (DV) */
    HIDRD_USAGE_KEYBOARD_KB_RIGHTCONTROL = _PU(0x00E4),
    /** Keyboard right shift (DV) */
    HIDRD_USAGE_KEYBOARD_KB_RIGHTSHIFT = _PU(0x00E5),
    /** Keyboard right alt (DV) */
    HIDRD_USAGE_KEYBOARD_KB_RIGHTALT = _PU(0x00E6),
    /** Keyboard right GUI (DV) */
    HIDRD_USAGE_KEYBOARD_KB_RIGHT_GUI = _PU(0x00E7),

#undef _PU

    /*
     * Consumer page
     */
#define _PU(_id) _U(CONSUMER, _id)

    /** Consumer control (CA) */
    HIDRD_USAGE_CONSUMER_CONSUMER_CONTROL = _PU(0x0001),
    /** Numeric key pad (NAry) */
    HIDRD_USAGE_CONSUMER_NUMERIC_KEYPAD = _PU(0x0002),
    /** Programmable buttons (NAry) */
    HIDRD_USAGE_CONSUMER_PROGRAMMABLE_BUTTONS = _PU(0x0003),
    /** Microphone (CA) */
    HIDRD_USAGE_CONSUMER_MICROPHONE = _PU(0x0004),
    /** Headphone (CA) */
    HIDRD_USAGE_CONSUMER_HEADPHONE = _PU(0x0005),
    /** Graphic equalizer (CA) */
    HIDRD_USAGE_CONSUMER_GRAPHIC_EQUALIZER = _PU(0x0006),
    /** +10 (OSC) */
    HIDRD_USAGE_CONSUMER_PLUS_10 = _PU(0x0020),
    /** +100 (OSC) */
    HIDRD_USAGE_CONSUMER_PLUS_100 = _PU(0x0021),
    /** AM/PM (OSC) */
    HIDRD_USAGE_CONSUMER_AM_PM = _PU(0x0022),
    /** Power (OOC) */
    HIDRD_USAGE_CONSUMER_POWER = _PU(0x0030),
    /** Reset (OSC) */
    HIDRD_USAGE_CONSUMER_RESET = _PU(0x0031),
    /** Sleep (OSC) */
    HIDRD_USAGE_CONSUMER_SLEEP = _PU(0x0032),
    /** Sleep after (OSC) */
    HIDRD_USAGE_CONSUMER_SLEEP_AFTER = _PU(0x0033),
    /** Sleep mode (RTC) */
    HIDRD_USAGE_CONSUMER_SLEEP_MODE = _PU(0x0034),
    /** Illumination (OOC) */
    HIDRD_USAGE_CONSUMER_ILLUMINATION = _PU(0x0035),
    /** Function buttons (NAry) */
    HIDRD_USAGE_CONSUMER_FUNCTION_BUTTONS = _PU(0x0036),
    /** Menu (OOC) */
    HIDRD_USAGE_CONSUMER_MENU = _PU(0x0040),
    /** Menu pick (OSC) */
    HIDRD_USAGE_CONSUMER_MENU_PICK = _PU(0x0041),
    /** Menu up (OSC) */
    HIDRD_USAGE_CONSUMER_MENU_UP = _PU(0x0042),
    /** Menu down (OSC) */
    HIDRD_USAGE_CONSUMER_MENU_DOWN = _PU(0x0043),
    /** Menu left (OSC) */
    HIDRD_USAGE_CONSUMER_MENU_LEFT = _PU(0x0044),
    /** Menu right (OSC) */
    HIDRD_USAGE_CONSUMER_MENU_RIGHT = _PU(0x0045),
    /** Menu escape (OSC) */
    HIDRD_USAGE_CONSUMER_MENU_ESCAPE = _PU(0x0046),
    /** Menu value increase (OSC) */
    HIDRD_USAGE_CONSUMER_MENU_VALUE_INC = _PU(0x0047),
    /** Menu value decrease (OSC) */
    HIDRD_USAGE_CONSUMER_MENU_VALUE_DEC = _PU(0x0048),
    /** Data on screen (OOC) */
    HIDRD_USAGE_CONSUMER_DATA_ON_SCREEN = _PU(0x0060),
    /** Closed caption (OOC) */
    HIDRD_USAGE_CONSUMER_CLOSED_CAPTION = _PU(0x0061),
    /** Closed caption select (OSC) */
    HIDRD_USAGE_CONSUMER_CLOSED_CAPTION_SELECT = _PU(0x0062),
    /** VCR/TV (OOC) */
    HIDRD_USAGE_CONSUMER_VCR_TV = _PU(0x0063),
    /** Broadcast mode (OSC) */
    HIDRD_USAGE_CONSUMER_BROADCAST_MODE = _PU(0x0064),
    /** Snapshot (OSC) */
    HIDRD_USAGE_CONSUMER_SNAPSHOT = _PU(0x0065),
    /** Still (OSC) */
    HIDRD_USAGE_CONSUMER_STILL = _PU(0x0066),
    /** Selection (NAry) */
    HIDRD_USAGE_CONSUMER_SELECTION = _PU(0x0080),
    /** Assign selection (OSC) */
    HIDRD_USAGE_CONSUMER_ASSIGN_SELECTION = _PU(0x0081),
    /** Mode step (OSC) */
    HIDRD_USAGE_CONSUMER_MODE_STEP = _PU(0x0082),
    /** Recall last (OSC) */
    HIDRD_USAGE_CONSUMER_RECALL_LAST = _PU(0x0083),
    /** Enter channel (OSC) */
    HIDRD_USAGE_CONSUMER_ENTER_CHANNEL = _PU(0x0084),
    /** Order movie (OSC) */
    HIDRD_USAGE_CONSUMER_ORDER_MOVIE = _PU(0x0085),
    /** Channel (LC) */
    HIDRD_USAGE_CONSUMER_CHANNEL = _PU(0x0086),
    /** Media selection (NAry) */
    HIDRD_USAGE_CONSUMER_MEDIA_SELECTION = _PU(0x0087),
    /** Media select computer (Sel) */
    HIDRD_USAGE_CONSUMER_MEDIA_SELECT_COMPUTER = _PU(0x0088),
    /** Media select TV (Sel) */
    HIDRD_USAGE_CONSUMER_MEDIA_SELECT_TV = _PU(0x0089),
    /** Media select WWW (Sel) */
    HIDRD_USAGE_CONSUMER_MEDIA_SELECT_WWW = _PU(0x008A),
    /** Media select DVD (Sel) */
    HIDRD_USAGE_CONSUMER_MEDIA_SELECT_DVD = _PU(0x008B),
    /** Media select telephone (Sel) */
    HIDRD_USAGE_CONSUMER_MEDIA_SELECT_TELEPHONE = _PU(0x008C),
    /** Media select program guide (Sel) */
    HIDRD_USAGE_CONSUMER_MEDIA_SELECT_PROGRAM_GUIDE = _PU(0x008D),
    /** Media select video phone (Sel) */
    HIDRD_USAGE_CONSUMER_MEDIA_SELECT_VIDEO_PHONE = _PU(0x008E),
    /** Media select games (Sel) */
    HIDRD_USAGE_CONSUMER_MEDIA_SELECT_GAMES = _PU(0x008F),
    /** Media select messages (Sel) */
    HIDRD_USAGE_CONSUMER_MEDIA_SELECT_MESSAGES = _PU(0x0090),
    /** Media select CD (Sel) */
    HIDRD_USAGE_CONSUMER_MEDIA_SELECT_CD = _PU(0x0091),
    /** Media select VCR (Sel) */
    HIDRD_USAGE_CONSUMER_MEDIA_SELECT_VCR = _PU(0x0092),
    /** Media select tuner (Sel) */
    HIDRD_USAGE_CONSUMER_MEDIA_SELECT_TUNER = _PU(0x0093),
    /** Quit (OSC) */
    HIDRD_USAGE_CONSUMER_QUIT = _PU(0x0094),
    /** Help (OOC) */
    HIDRD_USAGE_CONSUMER_HELP = _PU(0x0095),
    /** Media select tape (Sel) */
    HIDRD_USAGE_CONSUMER_MEDIA_SELECT_TAPE = _PU(0x0096),
    /** Media select cable (Sel) */
    HIDRD_USAGE_CONSUMER_MEDIA_SELECT_CABLE = _PU(0x0097),
    /** Media select satellite (Sel) */
    HIDRD_USAGE_CONSUMER_MEDIA_SELECT_SATELLITE = _PU(0x0098),
    /** Media select security (Sel) */
    HIDRD_USAGE_CONSUMER_MEDIA_SELECT_SECURITY = _PU(0x0099),
    /** Media select home (Sel) */
    HIDRD_USAGE_CONSUMER_MEDIA_SELECT_HOME = _PU(0x009A),
    /** Media select call (Sel) */
    HIDRD_USAGE_CONSUMER_MEDIA_SELECT_CALL = _PU(0x009B),
    /** Channel increment (OSC) */
    HIDRD_USAGE_CONSUMER_CHANNEL_INC = _PU(0x009C),
    /** Channel decrement (OSC) */
    HIDRD_USAGE_CONSUMER_CHANNEL_DEC = _PU(0x009D),
    /** Media select SAP (Sel) */
    HIDRD_USAGE_CONSUMER_MEDIA_SELECT_SAP = _PU(0x009E),
    /** VCR plus (OSC) */
    HIDRD_USAGE_CONSUMER_VCR_PLUS = _PU(0x00A0),
    /** Once (OSC) */
    HIDRD_USAGE_CONSUMER_ONCE = _PU(0x00A1),
    /** Daily (OSC) */
    HIDRD_USAGE_CONSUMER_DAILY = _PU(0x00A2),
    /** Weekly (OSC) */
    HIDRD_USAGE_CONSUMER_WEEKLY = _PU(0x00A3),
    /** Monthly (OSC) */
    HIDRD_USAGE_CONSUMER_MONTHLY = _PU(0x00A4),
    /** Play (OOC) */
    HIDRD_USAGE_CONSUMER_PLAY = _PU(0x00B0),
    /** Pause (OOC) */
    HIDRD_USAGE_CONSUMER_PAUSE = _PU(0x00B1),
    /** Record (OOC) */
    HIDRD_USAGE_CONSUMER_RECORD = _PU(0x00B2),
    /** Fast forward (OOC) */
    HIDRD_USAGE_CONSUMER_FAST_FORWARD = _PU(0x00B3),
    /** Rewind (OOC) */
    HIDRD_USAGE_CONSUMER_REWIND = _PU(0x00B4),
    /** Scan next track (OSC) */
    HIDRD_USAGE_CONSUMER_SCAN_NEXT_TRACK = _PU(0x00B5),
    /** Scan previous track (OSC) */
    HIDRD_USAGE_CONSUMER_SCAN_PREVIOUS_TRACK = _PU(0x00B6),
    /** Stop (OSC) */
    HIDRD_USAGE_CONSUMER_STOP = _PU(0x00B7),
    /** Eject (OSC) */
    HIDRD_USAGE_CONSUMER_EJECT = _PU(0x00B8),
    /** Random play (OOC) */
    HIDRD_USAGE_CONSUMER_RANDOM_PLAY = _PU(0x00B9),
    /** Select disc (NAry) */
    HIDRD_USAGE_CONSUMER_SELECT_DISC = _PU(0x00BA),
    /** Enter disc (MC) */
    HIDRD_USAGE_CONSUMER_ENTER_DISC = _PU(0x00BB),
    /** Repeat (OSC) */
    HIDRD_USAGE_CONSUMER_REPEAT = _PU(0x00BC),
    /** Tracking (LC) */
    HIDRD_USAGE_CONSUMER_TRACKING = _PU(0x00BD),
    /** Track normal (OSC) */
    HIDRD_USAGE_CONSUMER_TRACK_NORMAL = _PU(0x00BE),
    /** Slow tracking (LC) */
    HIDRD_USAGE_CONSUMER_SLOW_TRACKING = _PU(0x00BF),
    /** Frame forward (RTC) */
    HIDRD_USAGE_CONSUMER_FRAME_FORWARD = _PU(0x00C0),
    /** Frame back (RTC) */
    HIDRD_USAGE_CONSUMER_FRAME_BACK = _PU(0x00C1),
    /** Mark (OSC) */
    HIDRD_USAGE_CONSUMER_MARK = _PU(0x00C2),
    /** Clear mark (OSC) */
    HIDRD_USAGE_CONSUMER_CLEAR_MARK = _PU(0x00C3),
    /** Repeat from mark (OOC) */
    HIDRD_USAGE_CONSUMER_REPEAT_FROM_MARK = _PU(0x00C4),
    /** Return to mark (OSC) */
    HIDRD_USAGE_CONSUMER_RETURN_TO_MARK = _PU(0x00C5),
    /** Search mark forward (OSC) */
    HIDRD_USAGE_CONSUMER_SEARCH_MARK_FORWARD = _PU(0x00C6),
    /** Search mark backwards (OSC) */
    HIDRD_USAGE_CONSUMER_SEARCH_MARK_BACKWARDS = _PU(0x00C7),
    /** Counter Reset (OSC) */
    HIDRD_USAGE_CONSUMER_COUNTER_RESET = _PU(0x00C8),
    /** Show counter (OSC) */
    HIDRD_USAGE_CONSUMER_SHOW_COUNTER = _PU(0x00C9),
    /** Tracking increment (RTC) */
    HIDRD_USAGE_CONSUMER_TRACKING_INC = _PU(0x00CA),
    /** Tracking decrement (RTC) */
    HIDRD_USAGE_CONSUMER_TRACKING_DEC = _PU(0x00CB),
    /** Stop/eject (OSC) */
    HIDRD_USAGE_CONSUMER_STOP_EJECT = _PU(0x00CC),
    /** Play/pause (OSC) */
    HIDRD_USAGE_CONSUMER_PLAY_PAUSE = _PU(0x00CD),
    /** Play/skip (OSC) */
    HIDRD_USAGE_CONSUMER_PLAY_SKIP = _PU(0x00CE),
    /** Volume (LC) */
    HIDRD_USAGE_CONSUMER_VOLUME = _PU(0x00E0),
    /** Balance (LC) */
    HIDRD_USAGE_CONSUMER_BALANCE = _PU(0x00E1),
    /** Mute (OOC) */
    HIDRD_USAGE_CONSUMER_MUTE = _PU(0x00E2),
    /** Bass (LC) */
    HIDRD_USAGE_CONSUMER_BASS = _PU(0x00E3),
    /** Treble (LC) */
    HIDRD_USAGE_CONSUMER_TREBLE = _PU(0x00E4),
    /** Bass boost (OOC) */
    HIDRD_USAGE_CONSUMER_BASS_BOOST = _PU(0x00E5),
    /** Surround mode (OSC) */
    HIDRD_USAGE_CONSUMER_SURROUND_MODE = _PU(0x00E6),
    /** Loudness (OOC) */
    HIDRD_USAGE_CONSUMER_LOUDNESS = _PU(0x00E7),
    /** MPX (OOC) */
    HIDRD_USAGE_CONSUMER_MPX = _PU(0x00E8),
    /** Volume increment (RTC) */
    HIDRD_USAGE_CONSUMER_VOLUME_INC = _PU(0x00E9),
    /** Volume decrement (RTC) */
    HIDRD_USAGE_CONSUMER_VOLUME_DEC = _PU(0x00EA),
    /** Speed select (OSC) */
    HIDRD_USAGE_CONSUMER_SPEED_SELECT = _PU(0x00F0),
    /** Playback speed (NAry) */
    HIDRD_USAGE_CONSUMER_PLAYBACK_SPEED = _PU(0x00F1),
    /** Standard play (Sel) */
    HIDRD_USAGE_CONSUMER_STANDARD_PLAY = _PU(0x00F2),
    /** Long play (Sel) */
    HIDRD_USAGE_CONSUMER_LONG_PLAY = _PU(0x00F3),
    /** Extended play (Sel) */
    HIDRD_USAGE_CONSUMER_EXTENDED_PLAY = _PU(0x00F4),
    /** Slow (OSC) */
    HIDRD_USAGE_CONSUMER_SLOW = _PU(0x00F5),
    /** Fan enable (OOC) */
    HIDRD_USAGE_CONSUMER_FAN_ENABLE = _PU(0x0100),
    /** Fan speed (LC) */
    HIDRD_USAGE_CONSUMER_FAN_SPEED = _PU(0x0101),
    /** Light enable (OOC) */
    HIDRD_USAGE_CONSUMER_LIGHT_ENABLE = _PU(0x0102),
    /** Light illumination level (LC) */
    HIDRD_USAGE_CONSUMER_LIGHT_ILLUMINATION_LEVEL = _PU(0x0103),
    /** Climate control enable (OOC) */
    HIDRD_USAGE_CONSUMER_CLIMATE_CONTROL_ENABLE = _PU(0x0104),
    /** Room temperature (LC) */
    HIDRD_USAGE_CONSUMER_ROOM_TEMPERATURE = _PU(0x0105),
    /** Security enable (OOC) */
    HIDRD_USAGE_CONSUMER_SECURITY_ENABLE = _PU(0x0106),
    /** Fire alarm (OSC) */
    HIDRD_USAGE_CONSUMER_FIRE_ALARM = _PU(0x0107),
    /** Police alarm (OSC) */
    HIDRD_USAGE_CONSUMER_POLICE_ALARM = _PU(0x0108),
    /** Proximity (LC) */
    HIDRD_USAGE_CONSUMER_PROXIMITY = _PU(0x0109),
    /** Motion (OSC) */
    HIDRD_USAGE_CONSUMER_MOTION = _PU(0x010A),
    /** Duress alarm (OSC) */
    HIDRD_USAGE_CONSUMER_DURESS_ALARM = _PU(0x010B),
    /** Holdup alarm (OSC) */
    HIDRD_USAGE_CONSUMER_HOLDUP_ALARM = _PU(0x010C),
    /** Medical alarm (OSC) */
    HIDRD_USAGE_CONSUMER_MEDICAL_ALARM = _PU(0x010D),
    /** Balance right (RTC) */
    HIDRD_USAGE_CONSUMER_BALANCE_RIGHT = _PU(0x0150),
    /** Balance left (RTC) */
    HIDRD_USAGE_CONSUMER_BALANCE_LEFT = _PU(0x0151),
    /** Bass increment (RTC) */
    HIDRD_USAGE_CONSUMER_BASS_INC = _PU(0x0152),
    /** Bass decrement (RTC) */
    HIDRD_USAGE_CONSUMER_BASS_DEC = _PU(0x0153),
    /** Treble increment (RTC) */
    HIDRD_USAGE_CONSUMER_TREBLE_INC = _PU(0x0154),
    /** Treble decrement (RTC) */
    HIDRD_USAGE_CONSUMER_TREBLE_DEC = _PU(0x0155),
    /** Speaker system (CL) */
    HIDRD_USAGE_CONSUMER_SPEAKER_SYSTEM = _PU(0x0160),
    /** Channel left (CL) */
    HIDRD_USAGE_CONSUMER_CHANNEL_LEFT = _PU(0x0161),
    /** Channel right (CL) */
    HIDRD_USAGE_CONSUMER_CHANNEL_RIGHT = _PU(0x0162),
    /** Channel center (CL) */
    HIDRD_USAGE_CONSUMER_CHANNEL_CENTER = _PU(0x0163),
    /** Channel front (CL) */
    HIDRD_USAGE_CONSUMER_CHANNEL_FRONT = _PU(0x0164),
    /** Channel center front (CL) */
    HIDRD_USAGE_CONSUMER_CHANNEL_CENTER_FRONT = _PU(0x0165),
    /** Channel side (CL) */
    HIDRD_USAGE_CONSUMER_CHANNEL_SIDE = _PU(0x0166),
    /** Channel surround (CL) */
    HIDRD_USAGE_CONSUMER_CHANNEL_SURROUND = _PU(0x0167),
    /** Channel low frequency enhancement (CL) */
    HIDRD_USAGE_CONSUMER_CHANNEL_LOW_FREQ_ENHAN = _PU(0x0168),
    /** Channel top (CL) */
    HIDRD_USAGE_CONSUMER_CHANNEL_TOP = _PU(0x0169),
    /** Channel unknown (CL) */
    HIDRD_USAGE_CONSUMER_CHANNEL_UNKNOWN = _PU(0x016A),
    /** Sub-channel (LC) */
    HIDRD_USAGE_CONSUMER_SUBCHANNEL = _PU(0x0170),
    /** Sub-channel increment (OSC) */
    HIDRD_USAGE_CONSUMER_SUBCHANNEL_INC = _PU(0x0171),
    /** Sub-channel decrement (OSC) */
    HIDRD_USAGE_CONSUMER_SUBCHANNEL_DEC = _PU(0x0172),
    /** Alternate audio increment (OSC) */
    HIDRD_USAGE_CONSUMER_ALTERNATE_AUDIO_INC = _PU(0x0173),
    /** Alternate audio decrement (OSC) */
    HIDRD_USAGE_CONSUMER_ALTERNATE_AUDIO_DEC = _PU(0x0174),
    /** Application launch buttons (NAry) */
    HIDRD_USAGE_CONSUMER_APP_LAUNCH_BUTTONS = _PU(0x0180),
    /** AL launch button configuration tool (Sel) */
    HIDRD_USAGE_CONSUMER_AL_LAUNCH_BUTTON_CONFIG_TOOL = _PU(0x0181),
    /** AL programmable button configuration (Sel) */
    HIDRD_USAGE_CONSUMER_AL_PROGRAMMABLE_BUTTON_CONFIG = _PU(0x0182),
    /** AL consumer control configuration (Sel) */
    HIDRD_USAGE_CONSUMER_AL_CONSUMER_CONTROL_CONFIG = _PU(0x0183),
    /** AL word processor (Sel) */
    HIDRD_USAGE_CONSUMER_AL_WORD_PROC = _PU(0x0184),
    /** AL text editor (Sel) */
    HIDRD_USAGE_CONSUMER_AL_TEXT_EDITOR = _PU(0x0185),
    /** AL spreadsheet (Sel) */
    HIDRD_USAGE_CONSUMER_AL_SPREADSHEET = _PU(0x0186),
    /** AL graphics editor (Sel) */
    HIDRD_USAGE_CONSUMER_AL_GRAPHICS_EDITOR = _PU(0x0187),
    /** AL presentation app (Sel) */
    HIDRD_USAGE_CONSUMER_AL_PRESENTATION_APP = _PU(0x0188),
    /** AL database app (Sel) */
    HIDRD_USAGE_CONSUMER_AL_DATABASE_APP = _PU(0x0189),
    /** AL email reader (Sel) */
    HIDRD_USAGE_CONSUMER_AL_EMAIL_READER = _PU(0x018A),
    /** AL newsreader (Sel) */
    HIDRD_USAGE_CONSUMER_AL_NEWSREADER = _PU(0x018B),
    /** AL voicemail (Sel) */
    HIDRD_USAGE_CONSUMER_AL_VOICEMAIL = _PU(0x018C),
    /** AL contacts/address book (Sel) */
    HIDRD_USAGE_CONSUMER_AL_CONTACTS_OR_ADDRESS_BOOK = _PU(0x018D),
    /** AL calendar/schedule (Sel) */
    HIDRD_USAGE_CONSUMER_AL_CALENDAR_OR_SCHEDULE = _PU(0x018E),
    /** AL task/project manager (Sel) */
    HIDRD_USAGE_CONSUMER_AL_TASK_OR_PROJECT_MNGR = _PU(0x018F),
    /** AL log/journal/timecard (Sel) */
    HIDRD_USAGE_CONSUMER_AL_LOG_OR_JOURNAL_OR_TIMECARD = _PU(0x0190),
    /** AL checkbook/finance (Sel) */
    HIDRD_USAGE_CONSUMER_AL_CHECKBOOK_OR_FINANCE = _PU(0x0191),
    /** AL calculator (Sel) */
    HIDRD_USAGE_CONSUMER_AL_CALCULATOR = _PU(0x0192),
    /** AL A/V capture/playback (Sel) */
    HIDRD_USAGE_CONSUMER_AL_AV_CAPTURE_OR_PLAYBACK = _PU(0x0193),
    /** AL local machine browser (Sel) */
    HIDRD_USAGE_CONSUMER_AL_LOCAL_MACHINE_BRWSR = _PU(0x0194),
    /** AL LAN/WAN browser (Sel) */
    HIDRD_USAGE_CONSUMER_AL_LAN_OR_WAN_BRWSR = _PU(0x0195),
    /** AL Internet browser (Sel) */
    HIDRD_USAGE_CONSUMER_AL_INTERNET_BRWSR = _PU(0x0196),
    /** AL remote networking/ISP connect (Sel) */
    HIDRD_USAGE_CONSUMER_AL_REMOTE_NET_OR_ISP_CONNECT = _PU(0x0197),
    /** AL network conference (Sel) */
    HIDRD_USAGE_CONSUMER_AL_NETWORK_CONFERENCE = _PU(0x0198),
    /** AL network chat (Sel) */
    HIDRD_USAGE_CONSUMER_AL_NETWORK_CHAT = _PU(0x0199),
    /** AL telephony/dialer (Sel) */
    HIDRD_USAGE_CONSUMER_AL_TELEPHONY_OR_DIALER = _PU(0x019A),
    /** AL logon (Sel) */
    HIDRD_USAGE_CONSUMER_AL_LOGON = _PU(0x019B),
    /** AL logoff (Sel) */
    HIDRD_USAGE_CONSUMER_AL_LOGOFF = _PU(0x019C),
    /** AL logon/logoff (Sel) */
    HIDRD_USAGE_CONSUMER_AL_LOGON_OR_LOGOFF = _PU(0x019D),
    /** AL terminal lock/screensaver (Sel) */
    HIDRD_USAGE_CONSUMER_AL_TERM_LOCK_OR_SCREENSAVER = _PU(0x019E),
    /** AL control panel (Sel) */
    HIDRD_USAGE_CONSUMER_AL_CONTROL_PANEL = _PU(0x019F),
    /** AL command line processor/run (Sel) */
    HIDRD_USAGE_CONSUMER_AL_CMD_LINE_PROC_OR_RUN = _PU(0x01A0),
    /** AL process/task manager (Sel) */
    HIDRD_USAGE_CONSUMER_AL_PROC_OR_TASK_MNGR = _PU(0x01A1),
    /** AL select task/application (Sel) */
    HIDRD_USAGE_CONSUMER_AL_SELECT_TASK_OR_APP = _PU(0x01A2),
    /** AL next task/application (Sel) */
    HIDRD_USAGE_CONSUMER_AL_NEXT_TASK_OR_APP = _PU(0x01A3),
    /** AL previous task/application (Sel) */
    HIDRD_USAGE_CONSUMER_AL_PREVIOUS_TASK_OR_APP = _PU(0x01A4),
    /** AL preemptive halt task/application (Sel) */
    HIDRD_USAGE_CONSUMER_AL_PREEMPTIVE_HALT_TASK_OR_APP = _PU(0x01A5),
    /** AL integrated help center (Sel) */
    HIDRD_USAGE_CONSUMER_AL_INTEGRATED_HELP_CENTER = _PU(0x01A6),
    /** AL documents (Sel) */
    HIDRD_USAGE_CONSUMER_AL_DOCUMENTS = _PU(0x01A7),
    /** AL thesaurus (Sel) */
    HIDRD_USAGE_CONSUMER_AL_THESAURUS = _PU(0x01A8),
    /** AL dictionary (Sel) */
    HIDRD_USAGE_CONSUMER_AL_DICTIONARY = _PU(0x01A9),
    /** AL desktop (Sel) */
    HIDRD_USAGE_CONSUMER_AL_DESKTOP = _PU(0x01AA),
    /** AL spell check (Sel) */
    HIDRD_USAGE_CONSUMER_AL_SPELL_CHECK = _PU(0x01AB),
    /** AL grammar check (Sel) */
    HIDRD_USAGE_CONSUMER_AL_GRAMMAR_CHECK = _PU(0x01AC),
    /** AL wireless status (Sel) */
    HIDRD_USAGE_CONSUMER_AL_WIRELESS_STATUS = _PU(0x01AD),
    /** AL keyboard layout (Sel) */
    HIDRD_USAGE_CONSUMER_AL_KEYBOARD_LAYOUT = _PU(0x01AE),
    /** AL virus protection (Sel) */
    HIDRD_USAGE_CONSUMER_AL_VIRUS_PROTECTION = _PU(0x01AF),
    /** AL encryption (Sel) */
    HIDRD_USAGE_CONSUMER_AL_ENCRYPTION = _PU(0x01B0),
    /** AL screen saver (Sel) */
    HIDRD_USAGE_CONSUMER_AL_SCREEN_SAVER = _PU(0x01B1),
    /** AL alarms (Sel) */
    HIDRD_USAGE_CONSUMER_AL_ALARMS = _PU(0x01B2),
    /** AL clock (Sel) */
    HIDRD_USAGE_CONSUMER_AL_CLOCK = _PU(0x01B3),
    /** AL file browser (Sel) */
    HIDRD_USAGE_CONSUMER_AL_FILE_BRWSR = _PU(0x01B4),
    /** AL power status (Sel) */
    HIDRD_USAGE_CONSUMER_AL_POWER_STATUS = _PU(0x01B5),
    /** AL image browser (Sel) */
    HIDRD_USAGE_CONSUMER_AL_IMAGE_BRWSR = _PU(0x01B6),
    /** AL audio browser (Sel) */
    HIDRD_USAGE_CONSUMER_AL_AUDIO_BRWSR = _PU(0x01B7),
    /** AL movie browser (Sel) */
    HIDRD_USAGE_CONSUMER_AL_MOVIE_BRWSR = _PU(0x01B8),
    /** AL digital rights manager (Sel) */
    HIDRD_USAGE_CONSUMER_AL_DIGITAL_RIGHTS_MNGR = _PU(0x01B9),
    /** AL digital wallet (Sel) */
    HIDRD_USAGE_CONSUMER_AL_DIGITAL_WALLET = _PU(0x01BA),
    /** AL instant messaging (Sel) */
    HIDRD_USAGE_CONSUMER_AL_INSTANT_MESSAGING = _PU(0x01BC),
    /** AL OEM features/tips/tutorial browser (Sel) */
    HIDRD_USAGE_CONSUMER_AL_OEM_FEATS_BRWSR = _PU(0x01BD),
    /** AL OEM help (Sel) */
    HIDRD_USAGE_CONSUMER_AL_OEM_HELP = _PU(0x01BE),
    /** AL online community (Sel) */
    HIDRD_USAGE_CONSUMER_AL_ONLINE_COMMUNITY = _PU(0x01BF),
    /** AL entertainment content browser (Sel) */
    HIDRD_USAGE_CONSUMER_AL_ENT_CONTENT_BRWSR = _PU(0x01C0),
    /** AL online shopping browser (Sel) */
    HIDRD_USAGE_CONSUMER_AL_ONLINE_SHOPPING_BRWSR = _PU(0x01C1),
    /** AL smartcard information/help (Sel) */
    HIDRD_USAGE_CONSUMER_AL_SMARTCARD_INFO_OR_HELP = _PU(0x01C2),
    /** AL market monitor/finance browser (Sel) */
    HIDRD_USAGE_CONSUMER_AL_MRKT_MON_OR_FIN_BRWSR = _PU(0x01C3),
    /** AL customized corporate news browser (Sel) */
    HIDRD_USAGE_CONSUMER_AL_CUSTOM_CORP_NEWS_BRWSR = _PU(0x01C4),
    /** AL online activity browser (Sel) */
    HIDRD_USAGE_CONSUMER_AL_ONLINE_ACTIVITY_BRWSR = _PU(0x01C5),
    /** AL research/search browser (Sel) */
    HIDRD_USAGE_CONSUMER_AL_RESEARCH_OR_SEARCH_BRWSR = _PU(0x01C6),
    /** AL audio player (Sel) */
    HIDRD_USAGE_CONSUMER_AL_AUDIO_PLAYER = _PU(0x01C7),
    /** Generic GUI application controls (Nary) */
    HIDRD_USAGE_CONSUMER_GENERIC_GUI_APP_CONTROLS = _PU(0x0200),
    /** AC new (Sel) */
    HIDRD_USAGE_CONSUMER_AC_NEW = _PU(0x0201),
    /** AC open (Sel) */
    HIDRD_USAGE_CONSUMER_AC_OPEN = _PU(0x0202),
    /** AC close (Sel) */
    HIDRD_USAGE_CONSUMER_AC_CLOSE = _PU(0x0203),
    /** AC exit (Sel) */
    HIDRD_USAGE_CONSUMER_AC_EXIT = _PU(0x0204),
    /** AC maximize (Sel) */
    HIDRD_USAGE_CONSUMER_AC_MAXIMIZE = _PU(0x0205),
    /** AC minimize (Sel) */
    HIDRD_USAGE_CONSUMER_AC_MINIMIZE = _PU(0x0206),
    /** AC save (Sel) */
    HIDRD_USAGE_CONSUMER_AC_SAVE = _PU(0x0207),
    /** AC print (Sel) */
    HIDRD_USAGE_CONSUMER_AC_PRINT = _PU(0x0208),
    /** AC properties (Sel) */
    HIDRD_USAGE_CONSUMER_AC_PROPERTIES = _PU(0x0209),
    /** AC undo (Sel) */
    HIDRD_USAGE_CONSUMER_AC_UNDO = _PU(0x021A),
    /** AC copy (Sel) */
    HIDRD_USAGE_CONSUMER_AC_COPY = _PU(0x021B),
    /** AC cut (Sel) */
    HIDRD_USAGE_CONSUMER_AC_CUT = _PU(0x021C),
    /** AC paste (Sel) */
    HIDRD_USAGE_CONSUMER_AC_PASTE = _PU(0x021D),
    /** AC select all (Sel) */
    HIDRD_USAGE_CONSUMER_AC_SELECT_ALL = _PU(0x021E),
    /** AC find (Sel) */
    HIDRD_USAGE_CONSUMER_AC_FIND = _PU(0x021F),
    /** AC find and replace (Sel) */
    HIDRD_USAGE_CONSUMER_AC_FIND_AND_REPLACE = _PU(0x0220),
    /** AC search (Sel) */
    HIDRD_USAGE_CONSUMER_AC_SEARCH = _PU(0x0221),
    /** AC go to (Sel) */
    HIDRD_USAGE_CONSUMER_AC_GO_TO = _PU(0x0222),
    /** AC home (Sel) */
    HIDRD_USAGE_CONSUMER_AC_HOME = _PU(0x0223),
    /** AC back (Sel) */
    HIDRD_USAGE_CONSUMER_AC_BACK = _PU(0x0224),
    /** AC forward (Sel) */
    HIDRD_USAGE_CONSUMER_AC_FORWARD = _PU(0x0225),
    /** AC stop (Sel) */
    HIDRD_USAGE_CONSUMER_AC_STOP = _PU(0x0226),
    /** AC refresh (Sel) */
    HIDRD_USAGE_CONSUMER_AC_REFRESH = _PU(0x0227),
    /** AC previous link (Sel) */
    HIDRD_USAGE_CONSUMER_AC_PREVIOUS_LINK = _PU(0x0228),
    /** AC next link (Sel) */
    HIDRD_USAGE_CONSUMER_AC_NEXT_LINK = _PU(0x0229),
    /** AC bookmarks (Sel) */
    HIDRD_USAGE_CONSUMER_AC_BOOKMARKS = _PU(0x022A),
    /** AC history (Sel) */
    HIDRD_USAGE_CONSUMER_AC_HISTORY = _PU(0x022B),
    /** AC subscriptions (Sel) */
    HIDRD_USAGE_CONSUMER_AC_SUBSCRIPTIONS = _PU(0x022C),
    /** AC zoom in (Sel) */
    HIDRD_USAGE_CONSUMER_AC_ZOOM_IN = _PU(0x022D),
    /** AC zoom out (Sel) */
    HIDRD_USAGE_CONSUMER_AC_ZOOM_OUT = _PU(0x022E),
    /** AC zoom (LC) */
    HIDRD_USAGE_CONSUMER_AC_ZOOM = _PU(0x022F),
    /** AC full screen view (Sel) */
    HIDRD_USAGE_CONSUMER_AC_FULL_SCREEN_VIEW = _PU(0x0230),
    /** AC normal view (Sel) */
    HIDRD_USAGE_CONSUMER_AC_NORMAL_VIEW = _PU(0x0231),
    /** AC view toggle (Sel) */
    HIDRD_USAGE_CONSUMER_AC_VIEW_TOGGLE = _PU(0x0232),
    /** AC scroll up (Sel) */
    HIDRD_USAGE_CONSUMER_AC_SCROLL_UP = _PU(0x0233),
    /** AC scroll down (Sel) */
    HIDRD_USAGE_CONSUMER_AC_SCROLL_DOWN = _PU(0x0234),
    /** AC scroll (LC) */
    HIDRD_USAGE_CONSUMER_AC_SCROLL = _PU(0x0235),
    /** AC pan left (Sel) */
    HIDRD_USAGE_CONSUMER_AC_PAN_LEFT = _PU(0x0236),
    /** AC pan right (Sel) */
    HIDRD_USAGE_CONSUMER_AC_PAN_RIGHT = _PU(0x0237),
    /** AC pan (LC) */
    HIDRD_USAGE_CONSUMER_AC_PAN = _PU(0x0238),
    /** AC new window (Sel) */
    HIDRD_USAGE_CONSUMER_AC_NEW_WINDOW = _PU(0x0239),
    /** AC tile horizontally (Sel) */
    HIDRD_USAGE_CONSUMER_AC_TILE_HORIZ = _PU(0x023A),
    /** AC tile vertically (Sel) */
    HIDRD_USAGE_CONSUMER_AC_TILE_VERT = _PU(0x023B),
    /** AC format (Sel) */
    HIDRD_USAGE_CONSUMER_AC_FORMAT = _PU(0x023C),
    /** AC edit (Sel) */
    HIDRD_USAGE_CONSUMER_AC_EDIT = _PU(0x023D),
    /** AC bold (Sel) */
    HIDRD_USAGE_CONSUMER_AC_BOLD = _PU(0x023E),
    /** AC italics (Sel) */
    HIDRD_USAGE_CONSUMER_AC_ITALICS = _PU(0x023F),
    /** AC underline (Sel) */
    HIDRD_USAGE_CONSUMER_AC_UNDERLINE = _PU(0x0240),
    /** AC strikethrough (Sel) */
    HIDRD_USAGE_CONSUMER_AC_STRIKETHROUGH = _PU(0x0241),
    /** AC subscript (Sel) */
    HIDRD_USAGE_CONSUMER_AC_SUBSCRIPT = _PU(0x0242),
    /** AC superscript (Sel) */
    HIDRD_USAGE_CONSUMER_AC_SUPERSCRIPT = _PU(0x0243),
    /** AC all caps (Sel) */
    HIDRD_USAGE_CONSUMER_AC_ALL_CAPS = _PU(0x0244),
    /** AC rotate (Sel) */
    HIDRD_USAGE_CONSUMER_AC_ROTATE = _PU(0x0245),
    /** AC resize (Sel) */
    HIDRD_USAGE_CONSUMER_AC_RESIZE = _PU(0x0246),
    /** AC flip horizontal (Sel) */
    HIDRD_USAGE_CONSUMER_AC_FLIP_HORIZ = _PU(0x0247),
    /** AC flip vertical (Sel) */
    HIDRD_USAGE_CONSUMER_AC_FLIP_VERT = _PU(0x0248),
    /** AC mirror horizontal (Sel) */
    HIDRD_USAGE_CONSUMER_AC_MIRROR_HORIZ = _PU(0x0249),
    /** AC mirror vertical (Sel) */
    HIDRD_USAGE_CONSUMER_AC_MIRROR_VERT = _PU(0x024A),
    /** AC font select (Sel) */
    HIDRD_USAGE_CONSUMER_AC_FONT_SELECT = _PU(0x024B),
    /** AC font color (Sel) */
    HIDRD_USAGE_CONSUMER_AC_FONT_COLOR = _PU(0x024C),
    /** AC font size (Sel) */
    HIDRD_USAGE_CONSUMER_AC_FONT_SIZE = _PU(0x024D),
    /** AC justify left (Sel) */
    HIDRD_USAGE_CONSUMER_AC_JUSTIFY_LEFT = _PU(0x024E),
    /** AC justify center H (Sel) */
    HIDRD_USAGE_CONSUMER_AC_JUSTIFY_CENTER_H = _PU(0x024F),
    /** AC justify right (Sel) */
    HIDRD_USAGE_CONSUMER_AC_JUSTIFY_RIGHT = _PU(0x0250),
    /** AC justify block H (Sel) */
    HIDRD_USAGE_CONSUMER_AC_JUSTIFY_BLOCK_H = _PU(0x0251),
    /** AC justify top (Sel) */
    HIDRD_USAGE_CONSUMER_AC_JUSTIFY_TOP = _PU(0x0252),
    /** AC justify center V (Sel) */
    HIDRD_USAGE_CONSUMER_AC_JUSTIFY_CENTER_V = _PU(0x0253),
    /** AC justify bottom (Sel) */
    HIDRD_USAGE_CONSUMER_AC_JUSTIFY_BOTTOM = _PU(0x0254),
    /** AC justify block V (Sel) */
    HIDRD_USAGE_CONSUMER_AC_JUSTIFY_BLOCK_V = _PU(0x0255),
    /** AC indent decrease (Sel) */
    HIDRD_USAGE_CONSUMER_AC_INDENT_DEC = _PU(0x0256),
    /** AC indent increase (Sel) */
    HIDRD_USAGE_CONSUMER_AC_INDENT_INC = _PU(0x0257),
    /** AC numbered list (Sel) */
    HIDRD_USAGE_CONSUMER_AC_NUMBERED_LIST = _PU(0x0258),
    /** AC restart numbering (Sel) */
    HIDRD_USAGE_CONSUMER_AC_RESTART_NUMBERING = _PU(0x0259),
    /** AC bulleted list (Sel) */
    HIDRD_USAGE_CONSUMER_AC_BULLETED_LIST = _PU(0x025A),
    /** AC promote (Sel) */
    HIDRD_USAGE_CONSUMER_AC_PROMOTE = _PU(0x025B),
    /** AC demote (Sel) */
    HIDRD_USAGE_CONSUMER_AC_DEMOTE = _PU(0x025C),
    /** AC yes (Sel) */
    HIDRD_USAGE_CONSUMER_AC_YES = _PU(0x025D),
    /** AC no (Sel) */
    HIDRD_USAGE_CONSUMER_AC_NO = _PU(0x025E),
    /** AC cancel (Sel) */
    HIDRD_USAGE_CONSUMER_AC_CANCEL = _PU(0x025F),
    /** AC catalog (Sel) */
    HIDRD_USAGE_CONSUMER_AC_CATALOG = _PU(0x0260),
    /** AC buy/checkout (Sel) */
    HIDRD_USAGE_CONSUMER_AC_BUY_OR_CHECKOUT = _PU(0x0261),
    /** AC add to cart (Sel) */
    HIDRD_USAGE_CONSUMER_AC_ADD_TO_CART = _PU(0x0262),
    /** AC expand (Sel) */
    HIDRD_USAGE_CONSUMER_AC_EXPAND = _PU(0x0263),
    /** AC expand all (Sel) */
    HIDRD_USAGE_CONSUMER_AC_EXPAND_ALL = _PU(0x0264),
    /** AC collapse (Sel) */
    HIDRD_USAGE_CONSUMER_AC_COLLAPSE = _PU(0x0265),
    /** AC collapse all (Sel) */
    HIDRD_USAGE_CONSUMER_AC_COLLAPSE_ALL = _PU(0x0266),
    /** AC print preview (Sel) */
    HIDRD_USAGE_CONSUMER_AC_PRINT_PREVIEW = _PU(0x0267),
    /** AC paste special (Sel) */
    HIDRD_USAGE_CONSUMER_AC_PASTE_SPECIAL = _PU(0x0268),
    /** AC insert mode (Sel) */
    HIDRD_USAGE_CONSUMER_AC_INSERT_MODE = _PU(0x0269),
    /** AC delete (Sel) */
    HIDRD_USAGE_CONSUMER_AC_DELETE = _PU(0x026A),
    /** AC lock (Sel) */
    HIDRD_USAGE_CONSUMER_AC_LOCK = _PU(0x026B),
    /** AC unlock (Sel) */
    HIDRD_USAGE_CONSUMER_AC_UNLOCK = _PU(0x026C),
    /** AC protect (Sel) */
    HIDRD_USAGE_CONSUMER_AC_PROTECT = _PU(0x026D),
    /** AC unprotect (Sel) */
    HIDRD_USAGE_CONSUMER_AC_UNPROTECT = _PU(0x026E),
    /** AC attach comment (Sel) */
    HIDRD_USAGE_CONSUMER_AC_ATTACH_COMMENT = _PU(0x026F),
    /** AC delete comment (Sel) */
    HIDRD_USAGE_CONSUMER_AC_DELETE_COMMENT = _PU(0x0270),
    /** AC view comment (Sel) */
    HIDRD_USAGE_CONSUMER_AC_VIEW_COMMENT = _PU(0x0271),
    /** AC select word (Sel) */
    HIDRD_USAGE_CONSUMER_AC_SELECT_WORD = _PU(0x0272),
    /** AC select sentence (Sel) */
    HIDRD_USAGE_CONSUMER_AC_SELECT_SENTENCE = _PU(0x0273),
    /** AC select paragraph (Sel) */
    HIDRD_USAGE_CONSUMER_AC_SELECT_PARAGRAPH = _PU(0x0274),
    /** AC select column (Sel) */
    HIDRD_USAGE_CONSUMER_AC_SELECT_COLUMN = _PU(0x0275),
    /** AC select row (Sel) */
    HIDRD_USAGE_CONSUMER_AC_SELECT_ROW = _PU(0x0276),
    /** AC select table (Sel) */
    HIDRD_USAGE_CONSUMER_AC_SELECT_TABLE = _PU(0x0277),
    /** AC select object (Sel) */
    HIDRD_USAGE_CONSUMER_AC_SELECT_OBJECT = _PU(0x0278),
    /** AC redo/repeat (Sel) */
    HIDRD_USAGE_CONSUMER_AC_REDO_OR_REPEAT = _PU(0x0279),
    /** AC sort (Sel) */
    HIDRD_USAGE_CONSUMER_AC_SORT = _PU(0x027A),
    /** AC sort ascending (Sel) */
    HIDRD_USAGE_CONSUMER_AC_SORT_ASCENDING = _PU(0x027B),
    /** AC sort descending (Sel) */
    HIDRD_USAGE_CONSUMER_AC_SORT_DESCENDING = _PU(0x027C),
    /** AC filter (Sel) */
    HIDRD_USAGE_CONSUMER_AC_FILTER = _PU(0x027D),
    /** AC set clock (Sel) */
    HIDRD_USAGE_CONSUMER_AC_SET_CLOCK = _PU(0x027E),
    /** AC view clock (Sel) */
    HIDRD_USAGE_CONSUMER_AC_VIEW_CLOCK = _PU(0x027F),
    /** AC select time zone (Sel) */
    HIDRD_USAGE_CONSUMER_AC_SELECT_TIME_ZONE = _PU(0x0280),
    /** AC edit time zones (Sel) */
    HIDRD_USAGE_CONSUMER_AC_EDIT_TIME_ZONES = _PU(0x0281),
    /** AC set alarm (Sel) */
    HIDRD_USAGE_CONSUMER_AC_SET_ALARM = _PU(0x0282),
    /** AC clear alarm (Sel) */
    HIDRD_USAGE_CONSUMER_AC_CLEAR_ALARM = _PU(0x0283),
    /** AC snooze alarm (Sel) */
    HIDRD_USAGE_CONSUMER_AC_SNOOZE_ALARM = _PU(0x0284),
    /** AC reset alarm (Sel) */
    HIDRD_USAGE_CONSUMER_AC_RESET_ALARM = _PU(0x0285),
    /** AC synchronize (Sel) */
    HIDRD_USAGE_CONSUMER_AC_SYNCHRONIZE = _PU(0x0286),
    /** AC send/receive (Sel) */
    HIDRD_USAGE_CONSUMER_AC_SEND_OR_RECEIVE = _PU(0x0287),
    /** AC send to (Sel) */
    HIDRD_USAGE_CONSUMER_AC_SEND_TO = _PU(0x0288),
    /** AC reply (Sel) */
    HIDRD_USAGE_CONSUMER_AC_REPLY = _PU(0x0289),
    /** AC reply all (Sel) */
    HIDRD_USAGE_CONSUMER_AC_REPLY_ALL = _PU(0x028A),
    /** AC forward msg (Sel) */
    HIDRD_USAGE_CONSUMER_AC_FORWARD_MSG = _PU(0x028B),
    /** AC send (Sel) */
    HIDRD_USAGE_CONSUMER_AC_SEND = _PU(0x028C),
    /** AC attach file (Sel) */
    HIDRD_USAGE_CONSUMER_AC_ATTACH_FILE = _PU(0x028D),
    /** AC upload (Sel) */
    HIDRD_USAGE_CONSUMER_AC_UPLOAD = _PU(0x028E),
    /** AC download (save target as) (Sel) */
    HIDRD_USAGE_CONSUMER_AC_DOWNLOAD_AND_SAVE_AS = _PU(0x028F),
    /** AC set borders (Sel) */
    HIDRD_USAGE_CONSUMER_AC_SET_BORDERS = _PU(0x0290),
    /** AC insert row (Sel) */
    HIDRD_USAGE_CONSUMER_AC_INSERT_ROW = _PU(0x0291),
    /** AC insert column (Sel) */
    HIDRD_USAGE_CONSUMER_AC_INSERT_COLUMN = _PU(0x0292),
    /** AC insert file (Sel) */
    HIDRD_USAGE_CONSUMER_AC_INSERT_FILE = _PU(0x0293),
    /** AC insert picture (Sel) */
    HIDRD_USAGE_CONSUMER_AC_INSERT_PICTURE = _PU(0x0294),
    /** AC insert object (Sel) */
    HIDRD_USAGE_CONSUMER_AC_INSERT_OBJECT = _PU(0x0295),
    /** AC insert symbol (Sel) */
    HIDRD_USAGE_CONSUMER_AC_INSERT_SYMBOL = _PU(0x0296),
    /** AC save and close (Sel) */
    HIDRD_USAGE_CONSUMER_AC_SAVE_AND_CLOSE = _PU(0x0297),
    /** AC rename (Sel) */
    HIDRD_USAGE_CONSUMER_AC_RENAME = _PU(0x0298),
    /** AC merge (Sel) */
    HIDRD_USAGE_CONSUMER_AC_MERGE = _PU(0x0299),
    /** AC split (Sel) */
    HIDRD_USAGE_CONSUMER_AC_SPLIT = _PU(0x029A),
    /** AC disribute horizontally (Sel) */
    HIDRD_USAGE_CONSUMER_AC_DISRIBUTE_HORIZ = _PU(0x029B),
    /** AC distribute vertically (Sel) */
    HIDRD_USAGE_CONSUMER_AC_DISTRIBUTE_VERT = _PU(0x029C),

#undef _PU

    /*
     * Digitizer page
     */
#define _PU(_id) _U(DIGITIZER, _id)

    /** Digitizer (CA) */
    HIDRD_USAGE_DIGITIZER_DIGITIZER = _PU(0x0001),
    /** Pen (CA) */
    HIDRD_USAGE_DIGITIZER_PEN = _PU(0x0002),
    /** Light pen (CA) */
    HIDRD_USAGE_DIGITIZER_LIGHT_PEN = _PU(0x0003),
    /** Touch screen (CA) */
    HIDRD_USAGE_DIGITIZER_TOUCHSCREEN = _PU(0x0004),
    /** Touch pad (CA) */
    HIDRD_USAGE_DIGITIZER_TOUCHPAD = _PU(0x0005),
    /** White board (CA) */
    HIDRD_USAGE_DIGITIZER_WHITEBOARD = _PU(0x0006),
    /** Coordinate measuring machine (CA) */
    HIDRD_USAGE_DIGITIZER_COORD_MEASURING_MACHINE = _PU(0x0007),
    /** 3D digitizer (CA) */
    HIDRD_USAGE_DIGITIZER_3D_DIGITIZER = _PU(0x0008),
    /** Stereo plotter (CA) */
    HIDRD_USAGE_DIGITIZER_STEREO_PLOTTER = _PU(0x0009),
    /** Articulated arm (CA) */
    HIDRD_USAGE_DIGITIZER_ARTICULATED_ARM = _PU(0x000A),
    /** Armature (CA) */
    HIDRD_USAGE_DIGITIZER_ARMATURE = _PU(0x000B),
    /** Multiple point digitizer (CA) */
    HIDRD_USAGE_DIGITIZER_MULTIPOINT_DIGITIZER = _PU(0x000C),
    /** Free space wand (CA) */
    HIDRD_USAGE_DIGITIZER_FREE_SPACE_WAND = _PU(0x000D),
    /** Stylus (CL) */
    HIDRD_USAGE_DIGITIZER_STYLUS = _PU(0x0020),
    /** Puck (CL) */
    HIDRD_USAGE_DIGITIZER_PUCK = _PU(0x0021),
    /** Finger (CL) */
    HIDRD_USAGE_DIGITIZER_FINGER = _PU(0x0022),
    /** Tip pressure (DV) */
    HIDRD_USAGE_DIGITIZER_TIP_PRESSURE = _PU(0x0030),
    /** Barrel pressure (DV) */
    HIDRD_USAGE_DIGITIZER_BARREL_PRESSURE = _PU(0x0031),
    /** In range (MC) */
    HIDRD_USAGE_DIGITIZER_IN_RANGE = _PU(0x0032),
    /** Touch (MC) */
    HIDRD_USAGE_DIGITIZER_TOUCH = _PU(0x0033),
    /** Untouch (OSC) */
    HIDRD_USAGE_DIGITIZER_UNTOUCH = _PU(0x0034),
    /** Tap (OSC) */
    HIDRD_USAGE_DIGITIZER_TAP = _PU(0x0035),
    /** Quality (DV) */
    HIDRD_USAGE_DIGITIZER_QUALITY = _PU(0x0036),
    /** Data valid (MC) */
    HIDRD_USAGE_DIGITIZER_DATA_VALID = _PU(0x0037),
    /** Transducer index (DV) */
    HIDRD_USAGE_DIGITIZER_TRANSDUCER_INDEX = _PU(0x0038),
    /** Tablet function keys (CL) */
    HIDRD_USAGE_DIGITIZER_TABLET_FUNCTION_KEYS = _PU(0x0039),
    /** Program change keys (CL) */
    HIDRD_USAGE_DIGITIZER_PROGRAM_CHANGE_KEYS = _PU(0x003A),
    /** Battery strength (DV) */
    HIDRD_USAGE_DIGITIZER_BATTERY_STRENGTH = _PU(0x003B),
    /** Invert (MC) */
    HIDRD_USAGE_DIGITIZER_INVERT = _PU(0x003C),
    /** X tilt (DV) */
    HIDRD_USAGE_DIGITIZER_X_TILT = _PU(0x003D),
    /** Y tilt (DV) */
    HIDRD_USAGE_DIGITIZER_Y_TILT = _PU(0x003E),
    /** Azimuth (DV) */
    HIDRD_USAGE_DIGITIZER_AZIMUTH = _PU(0x003F),
    /** Altitude (DV) */
    HIDRD_USAGE_DIGITIZER_ALTITUDE = _PU(0x0040),
    /** Twist (DV) */
    HIDRD_USAGE_DIGITIZER_TWIST = _PU(0x0041),
    /** Tip switch (MC) */
    HIDRD_USAGE_DIGITIZER_TIP_SWITCH = _PU(0x0042),
    /** Secondary tip switch (MC) */
    HIDRD_USAGE_DIGITIZER_SECONDARY_TIP_SWITCH = _PU(0x0043),
    /** Barrel switch (MC) */
    HIDRD_USAGE_DIGITIZER_BARREL_SWITCH = _PU(0x0044),
    /** Eraser (MC) */
    HIDRD_USAGE_DIGITIZER_ERASER = _PU(0x0045),
    /** Tablet pick (MC) */
    HIDRD_USAGE_DIGITIZER_TABLET_PICK = _PU(0x0046),

#undef _PU

#undef _U
} hidrd_usage;

#define HIDRD_USAGE_MIN 0
#define HIDRD_USAGE_MAX UINT32_MAX

/**
 * Check if a usage is valid.
 *
 * @param usage Usage to check.
 *
 * @return True if usage is valid, false otherwise.
 */
extern bool hidrd_usage_valid(hidrd_usage usage);

/**
 * Check if a usage is known, in effect, if there is a description for it.
 *
 * @param usage Usage to check.
 *
 * @return True if the usage is known, false otherwise.
 */
extern bool hidrd_usage_known(hidrd_usage usage);

/* Declare usage to string conversion functions */
HIDRD_NUM_CONV_DECLS(usage);

/**
 * Retrieve usage page from a usage.
 *
 * @param usage Usage to retrieve usage page from.
 *
 * @return Usage page.
 */
static inline hidrd_usage_page
hidrd_usage_get_page(hidrd_usage usage)
{
    assert(hidrd_usage_valid(usage));
    return (usage >> 16) & UINT16_MAX;
}


/**
 * Check if a usage has defined page.
 *
 * @param usage Usage to check.
 *
 * @return True if the usage has defined page, false otherwise.
 */
static inline bool
hidrd_usage_defined_page(hidrd_usage usage)
{
    assert(hidrd_usage_valid(usage));
    return hidrd_usage_page_defined(hidrd_usage_get_page(usage));
}


/**
 * Set usage page.
 *
 * @param usage Usage to set page to.
 * @param page  Usage page to set.
 *
 * @return Usage with modified page.
 */
static inline hidrd_usage
hidrd_usage_set_page(hidrd_usage usage, hidrd_usage_page page)
{
    assert(hidrd_usage_valid(usage));
    assert(hidrd_usage_page_valid(page));
    return (usage & UINT16_MAX) | (page << 16);
}


/**
 * Retrieve usage ID from a usage.
 *
 * @param usage Usage to retrieve usage ID from.
 *
 * @return Usage ID.
 */
static inline hidrd_usage_id
hidrd_usage_get_id(hidrd_usage usage)
{
    assert(hidrd_usage_valid(usage));
    return usage & UINT16_MAX;
}


/**
 * Set usage ID.
 *
 * @param usage Usage to set ID to.
 * @param page  Usage ID to set.
 *
 * @return Usage with modified ID.
 */
static inline hidrd_usage
hidrd_usage_set_id(hidrd_usage usage, hidrd_usage_id id)
{
    assert(hidrd_usage_valid(usage));
    assert(hidrd_usage_id_valid(id));
    return (usage & (UINT16_MAX << 16)) | id;
}


/**
 * Compose a new usage from usage page and ID.
 *
 * @param page  Usage page.
 * @param id    Usage ID.
 *
 * @return New usage.
 */
static inline hidrd_usage
hidrd_usage_compose(hidrd_usage_page page, hidrd_usage_id id)
{
    assert(hidrd_usage_page_valid(page));
    assert(hidrd_usage_id_valid(id));
    return (page << 16) | id;
}


/**
 * Check if a usage is top-level (in effect, if its ID is top-level).
 *
 * @param usage Usage to check.
 *
 * @return True if the usage is top-level, false otherwise.
 */
static inline bool
hidrd_usage_top_level(hidrd_usage usage)
{
    assert(hidrd_usage_valid(usage));
    return hidrd_usage_id_top_level(hidrd_usage_get_id(usage));
}


#ifdef HIDRD_WITH_TOKENS
/**
 * Convert a usage to a string token.
 *
 * @param usage Usage.
 *
 * @return Dynamically allocated usage token, or NULL if no token was found
 *         or failed to allocate memory (check errno for the latter).
 */
extern char *hidrd_usage_to_token(hidrd_usage usage);


/**
 * Convert a usage to a ID token string.
 *
 * @param usage Usage.
 *
 * @return Dynamically allocated usage ID token, or NULL if no token was
 *         found or failed to allocate memory (check errno for the latter).
 */
extern char *hidrd_usage_to_id_token(hidrd_usage usage);


/**
 * Convert a string token to a usage.
 *
 * @param pusage    Location for usage; will not be modified in case of
 *                  error; could be NULL.
 * @param token     String token.
 *
 * @return True if token is found, false otherwise.
 */
extern bool hidrd_usage_from_token(hidrd_usage *pusage,
                                   const char  *token);

#endif /* HIDRD_WITH_TOKENS */

#ifdef HIDRD_WITH_NAMES

/**
 * Retrieve usage ID name string (close to specification).
 *
 * @param usage Usage code.
 *
 * @return Usage ID name string, or NULL if not found.
 */
extern const char *hidrd_usage_id_name(hidrd_usage usage);

#ifdef HIDRD_WITH_TOKENS

/**
 * Format description of usage ID as used in particular usage.
 *
 * @param usage Usage code to generate ID description for.
 *
 * @return Dynamically allocated usage ID description, or NULL if failed to
 *         allocate memory; could be an empty string, if there is nothing to
 *         tell about the usage ID.
 */
extern char *hidrd_usage_desc_id_str(hidrd_usage usage);

/**
 * Format usage description.
 *
 * @param usage Usage code to generate description for.
 *
 * @return Dynamically allocated usage description, or NULL if failed to
 *         allocate memory; could be an empty string, if there is nothing to
 *         tell about the usage.
 */
extern char *hidrd_usage_desc_str(hidrd_usage usage);

#endif /* HIDRD_WITH_TOKENS */

#endif /* HIDRD_WITH_NAMES */

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* __HIDRD_USAGE_ALL_H__ */
